package com.zcloud.modules.kangzai.controller;

import com.zcloud.common.annotation.SysLog;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.common.utils.R;
import com.zcloud.modules.kangzai.entity.BusTailingsReservoirEntity;
import com.zcloud.modules.kangzai.service.BusTailingsReservoirService;
import com.zcloud.modules.sys.controller.AbstractController;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import java.util.Map;

/**
 * @Author fangjiakai
 * @Desc 尾矿库基本信息表(BusTailingsReservoir)表控制层
 * @Date 2025-06-09 10:14:59
 */
@Api(tags = "尾矿库基本信息表")
@RestController
@RequestMapping("busTailingsReservoir")
public class BusTailingsReservoirController extends AbstractController {

    @Autowired
    private BusTailingsReservoirService busTailingsReservoirService;

    @ApiOperation("尾矿库基本信息表-新增数据")
    @SysLog("尾矿库基本信息表-新增数据")
    @PostMapping("/save")
    public R insert(@RequestBody BusTailingsReservoirEntity param) {
        param.setCreator(getUserId());
        param.setOperator(getUserId());
        busTailingsReservoirService.save(param);

        return R.ok();
    }

    @ApiOperation("尾矿库基本信息表-编辑数据")
    @SysLog("尾矿库基本信息表-编辑数据")
    @PostMapping("/update")
    public R update(@RequestBody BusTailingsReservoirEntity param) {
        param.setOperator(getUserId());
        busTailingsReservoirService.updateById(param);

        return R.ok();
    }


    @ApiOperation("尾矿库基本信息表-删除数据")
    @SysLog("尾矿库基本信息表-删除数据")
    @PostMapping("/delete")
    public R delete(@RequestBody BusTailingsReservoirEntity param) {
        busTailingsReservoirService.delete(param.getTailingsReservoirId(), getUserId());
        return R.ok();
    }

    @ApiOperation("尾矿库基本信息表-分页查询")
    @SysLog("尾矿库基本信息表-分页查询")
    @PostMapping("/listPage")
    public R listPage(@RequestBody Map<String, Object> params) {
        PageUtils page = busTailingsReservoirService.listPage(params);

        return R.ok().put("page", page);
    }


    @ApiOperation("尾矿库基本信息表-根据ID查详情")
    @SysLog("尾矿库基本信息表-根据ID查详情")
    @PostMapping("/info")
    public R info(@RequestBody BusTailingsReservoirEntity param) {
        BusTailingsReservoirEntity busTailingsReservoir = busTailingsReservoirService.getById(param.getTailingsReservoirId());
        return R.ok().put("busTailingsReservoir", busTailingsReservoir);
    }

}
